import sys
import os
import random
import math

def fail(t):
	print("Wrong Answer on test %d" % t)
	sys.exit(0)

def my_max(l):
	try:
		return max(l)
	except ValueError:
		return -1

def equalifyVector(l, l2):
	if type(l) is type(l2):
		if type(l) is list:
			if len(l) != len(l2):
				return False
			u = my_max(map(lambda i:abs(l[i]-l2[i])/max(abs(l[i]),abs(l2[i]),1),range(0,len(l))))
			if u >= 1e-7:
				return False
			return True
		else:
			if abs(l - l2) / max(abs(l), abs(l2), 1) >= 1e-7:
				return False
			return True
	return False

def parse(s, u=0):
	idx = s.find("(", u) + 1
	if idx == 0:
		return float(s)
	idx2 = s.find(")", idx)
	try:
		return list(map(float, s[idx:idx2].split(",")))
	except ValueError:
		return []

def remove_brackets(s):
	idx2 = s.find(" and ")
	return s[:s.find("to ") + 3] + s[idx2:idx2+5]

def pick(u):
	return math.pow(10, random.gauss(0, u))

if __name__ == "__main__":
	try:
		if sys.argv[1] == "make":
			c = 151
			try:
				c = int(sys.argv[2]) + 1
			except:
				pass
			for i in range(1, c):
				op = random.randint(4, 15)
				if op & 8:
					n = random.randint(0, 4096 // c - 1) + i * (4096 // c)
				else:
					n = 0
				if op & 4:
					if op & 8:
						if random.randint(0, 1) == 0:
							m = n
						else:
							m = random.randint(0, 4096 // c - 1) + i * (4096 // c)
					else:
						m = random.randint(0, 4096 // c - 1) + i * (4096 // c)
				else:
					m = 0
				if n == 0:
					ln = ["%.17f" % pick(i / c * 4)]
				else:
					ln = ["%.17f" % pick(i / c * 4) for _ in '.' * n]
				if m == 0:
					lm = ["%.17f" % pick(i / c * 4)]
				else:
					lm = ["%.17f" % pick(i / c * 4) for _ in '.' * m]
				with open("tests/i%d.txt" % i, "w") as f:
					writel = ["%d %d" % (n, m), " ".join(ln), " ".join(lm), "%d" % (op & 3)]
					f.write('\n'.join(writel))
				os.system("./mainApp tests/i%d.txt make > tests/o%d.txt" % (i, i))
		elif sys.argv[1] == "makeans":
			i = 0
			while True:
				try:
					with open("tests/i%d.txt" % (i + 1)) as f:
						i += 1
				except:
					break
				os.system("./mainApp tests/i%d.txt make > tests/o%d.txt" % (i, i))
	except IndexError:
		pass

	tc_num = 0
	while True:
		try:
			with open("tests/i%d.txt" % (tc_num + 1)) as f:
				tc_num += 1
		except:
			break
		with open("tests/o%d.txt" % tc_num) as f:
			remaining = f.readlines()
			if len(remaining) == 2:
				error = True
				error_msg = remaining[0]
				first = parse(error_msg[error_msg.find("to ") + 3:error_msg.find(" and ")])
				second = parse(error_msg[error_msg.find(" and ") + 5:])
				error_msg = remove_brackets(error_msg).strip()
			else:
				error = False
			l = parse(remaining[-1])
		os.system("./mainApp tests/i%d.txt > temp.txt" % tc_num)
		with open("temp.txt") as f:
			l2 = f.readlines()
			if error:
				if len(l2) == 2:
					now_error_msg = l2[0]
					try:
						if not equalifyVector(parse(now_error_msg[now_error_msg.find("to ") + 3:now_error_msg.find(" and ")]), first):
							fail(tc_num)
						elif not equalifyVector(parse(now_error_msg[now_error_msg.find(" and ") + 5:]), second):
							fail(tc_num)
						elif remove_brackets(now_error_msg).strip() != error_msg:
							fail(tc_num)
					except:
						fail(tc_num)
					l2 = parse(l2[1])
				else:
					fail(tc_num)
			else:
				if len(l2) == 1:
					l2 = parse(l2[0])
				else:
					fail(tc_num)
		if not equalifyVector(l, l2):
			fail(tc_num)
	print("AC!")
